/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.gen.ui.wizards.product;

import java.util.ArrayList;
import java.util.List;

/**
 * The class used to configure all the JET generations of the
 * 'AcceleoExportToProductWizard' wizard. The purpose of the wizard is to create
 * a new product (i.e an eclipse plug-in) for one or several Acceleo modules.
 * 
 * @author <a href="mailto:jonathan.musset@obeo.fr">Jonathan Musset</a>
 */
public class AcceleoCreateModuleProductData extends ProductData {

	public AcceleoCreateModuleProductData(String productID, List pluginDependencies) {
		super(productID, pluginDependencies);
		moduleTemplates = new ArrayList();
	}

	/**
	 * Acceleo templates.
	 */
	private List moduleTemplates;

	/**
	 * Gets the module templates.
	 * 
	 * @return the module templates
	 */
	public List getModuleTemplates() {
		return moduleTemplates;
	}
}
