/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */

package fr.obeo.acceleo.uml14.mof;

import fr.obeo.acceleo.tools.log.AcceleoException;

/**
 * Exception for MDR model reader.
 * 
 * @author www.obeo.fr
 * 
 */
public class ModelReaderException extends AcceleoException {

	private static final long serialVersionUID = 1;

	/**
	 * Indicates if it's a blocking exception.
	 */
	protected boolean blocking;

	/**
	 * Constructor.
	 * 
	 * @param message
	 *            is the message
	 */
	public ModelReaderException(String message, boolean blocking) {
		super(message);
		this.blocking = blocking;
	}

	/**
	 * Indicates if it's a blocking exception.
	 * 
	 * @return true if it's a blocking exception
	 */
	public boolean isBlocking() {
		return blocking;
	}

}
