/*
 * Copyright (c) 2005-2008 Obeo
 * 
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Obeo - initial API and implementation
 */
package fr.obeo.acceleo.gen.profiler.presentation;

/**
 * Sort status class for the profiler view.
 * 
 * @author Yvan LUSSAUD <a
 *         href="mailto:yvan.lussaud@obeo.fr">yvan.lussaud@obeo.fr</a>
 * 
 */
public class ProfilerSortStatus {
	/**
	 * Constant to sort viewer by time.
	 * 
	 * @generated NOT
	 */
	protected final static int SORT_BY_CREATION_TIME = 0;

	/**
	 * Constant to unsort viewer.
	 * 
	 * @generated NOT
	 */
	protected final static int SORT_BY_TIME = 1;

	/**
	 * Constant to unsort viewer.
	 * 
	 * @generated NOT
	 */
	protected int sortOrder = SORT_BY_CREATION_TIME;

	/**
	 * Getter for the current sort order.
	 * 
	 * @return the current sort order
	 */
	public int getSortOrder() {
		return sortOrder;
	}

	/**
	 * Setter for the current sort order.
	 * 
	 * @param sortOreder
	 *            the new sort order
	 */
	public void setSortOrder(int sortOreder) {
		this.sortOrder= sortOreder;
	}
}
