/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml13.behavioral_elements.collaborations;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action;
import fr.obeo.acceleo.uml13.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Message</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getInteraction
 * <em>Interaction</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getActivator
 * <em>Activator</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage4
 * <em>Message4</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getSender
 * <em>Sender</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getReceiver
 * <em>Receiver</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage3
 * <em>Message3</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getPredecessor
 * <em>Predecessor</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getCommunicationConnection
 * <em>Communication Connection</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getAction
 * <em>Action</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage()
 * @model
 * @generated
 */
public interface Message extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Interaction</b></em>' container
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Interaction#getMessage
	 * <em>Message</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interaction</em>' container reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Interaction</em>' container reference.
	 * @see #setInteraction(Interaction)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Interaction()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Interaction#getMessage
	 * @model opposite="message" required="true"
	 * @generated
	 */
	Interaction getInteraction();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getInteraction
	 * <em>Interaction</em>}' container reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Interaction</em>' container
	 *            reference.
	 * @see #getInteraction()
	 * @generated
	 */
	void setInteraction(Interaction value);

	/**
	 * Returns the value of the '<em><b>Activator</b></em>' reference. It
	 * is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage4
	 * <em>Message4</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Activator</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Activator</em>' reference.
	 * @see #setActivator(Message)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Activator()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage4
	 * @model opposite="message4"
	 * @generated
	 */
	Message getActivator();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getActivator
	 * <em>Activator</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Activator</em>' reference.
	 * @see #getActivator()
	 * @generated
	 */
	void setActivator(Message value);

	/**
	 * Returns the value of the '<em><b>Message4</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message}.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getActivator
	 * <em>Activator</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Message4</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Message4</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Message4()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getActivator
	 * @model type="fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message"
	 *        opposite="activator"
	 * @generated
	 */
	EList getMessage4();

	/**
	 * Returns the value of the '<em><b>Sender</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getMessage2
	 * <em>Message2</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Sender</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Sender</em>' reference.
	 * @see #setSender(ClassifierRole)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Sender()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getMessage2
	 * @model opposite="message2" required="true"
	 * @generated
	 */
	ClassifierRole getSender();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getSender
	 * <em>Sender</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Sender</em>' reference.
	 * @see #getSender()
	 * @generated
	 */
	void setSender(ClassifierRole value);

	/**
	 * Returns the value of the '<em><b>Receiver</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getMessage1
	 * <em>Message1</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Receiver</em>' reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Receiver</em>' reference.
	 * @see #setReceiver(ClassifierRole)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Receiver()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.ClassifierRole#getMessage1
	 * @model opposite="message1" required="true"
	 * @generated
	 */
	ClassifierRole getReceiver();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getReceiver
	 * <em>Receiver</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Receiver</em>' reference.
	 * @see #getReceiver()
	 * @generated
	 */
	void setReceiver(ClassifierRole value);

	/**
	 * Returns the value of the '<em><b>Message3</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message}.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getPredecessor
	 * <em>Predecessor</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Message3</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Message3</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Message3()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getPredecessor
	 * @model type="fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message"
	 *        opposite="predecessor"
	 * @generated
	 */
	EList getMessage3();

	/**
	 * Returns the value of the '<em><b>Predecessor</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message}.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage3
	 * <em>Message3</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Predecessor</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Predecessor</em>' reference list.
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Predecessor()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getMessage3
	 * @model type="fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message"
	 *        opposite="message3"
	 * @generated
	 */
	EList getPredecessor();

	/**
	 * Returns the value of the '<em><b>Communication Connection</b></em>'
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.AssociationRole#getMessage
	 * <em>Message</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Communication Connection</em>' reference
	 * isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Communication Connection</em>'
	 *         reference.
	 * @see #setCommunicationConnection(AssociationRole)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_CommunicationConnection()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.AssociationRole#getMessage
	 * @model opposite="message"
	 * @generated
	 */
	AssociationRole getCommunicationConnection();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getCommunicationConnection
	 * <em>Communication Connection</em>}' reference. <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Communication Connection</em>'
	 *            reference.
	 * @see #getCommunicationConnection()
	 * @generated
	 */
	void setCommunicationConnection(AssociationRole value);

	/**
	 * Returns the value of the '<em><b>Action</b></em>' reference. It is
	 * bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getMessage
	 * <em>Message</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Action</em>' reference isn't clear, there
	 * really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Action</em>' reference.
	 * @see #setAction(Action)
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.collaborations.CollaborationsPackage#getMessage_Action()
	 * @see fr.obeo.acceleo.uml13.behavioral_elements.common_behavior.Action#getMessage
	 * @model opposite="message" required="true"
	 * @generated
	 */
	Action getAction();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml13.behavioral_elements.collaborations.Message#getAction
	 * <em>Action</em>}' reference. <!-- begin-user-doc --> <!-- end-user-doc
	 * -->
	 * 
	 * @param value
	 *            the new value of the '<em>Action</em>' reference.
	 * @see #getAction()
	 * @generated
	 */
	void setAction(Action value);

} // Message
