/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectContainmentWithInverseEList;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Collaboration;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.CollaborationsPackage;
import fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Interaction;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.ModelElement;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.core.impl.GeneralizableElementImpl;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Collaboration</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.CollaborationImpl#getOwnedElement
 * <em>Owned Element</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.CollaborationImpl#getInteraction
 * <em>Interaction</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.impl.CollaborationImpl#getConstrainingElement
 * <em>Constraining Element</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class CollaborationImpl extends GeneralizableElementImpl implements Collaboration {
	/**
	 * The cached value of the '{@link #getOwnedElement()
	 * <em>Owned Element</em>}' containment reference list. <!--
	 * begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getOwnedElement()
	 * @generated
	 * @ordered
	 */
	protected EList ownedElement = null;

	/**
	 * The cached value of the '{@link #getInteraction() <em>Interaction</em>}'
	 * containment reference list. <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @see #getInteraction()
	 * @generated
	 * @ordered
	 */
	protected EList interaction = null;

	/**
	 * The cached value of the '{@link #getConstrainingElement()
	 * <em>Constraining Element</em>}' reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getConstrainingElement()
	 * @generated
	 * @ordered
	 */
	protected EList constrainingElement = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected CollaborationImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CollaborationsPackage.eINSTANCE.getCollaboration();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getOwnedElement() {
		if (ownedElement == null) {
			ownedElement = new EObjectContainmentWithInverseEList(ModelElement.class, this, CollaborationsPackage.COLLABORATION__OWNED_ELEMENT, CorePackage.MODEL_ELEMENT__NAMESPACE);
		}
		return ownedElement;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getInteraction() {
		if (interaction == null) {
			interaction = new EObjectContainmentWithInverseEList(Interaction.class, this, CollaborationsPackage.COLLABORATION__INTERACTION, CollaborationsPackage.INTERACTION__CONTEXT);
		}
		return interaction;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getConstrainingElement() {
		if (constrainingElement == null) {
			constrainingElement = new EObjectWithInverseResolvingEList.ManyInverse(ModelElement.class, this, CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT,
					CorePackage.MODEL_ELEMENT__COLLABORATION);
		}
		return constrainingElement;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.COLLABORATION__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.COLLABORATION__NAMESPACE, msgs);
			case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.COLLABORATION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__INTERACTION:
				return ((InternalEList) getInteraction()).basicAdd(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
				return ((InternalEList) getConstrainingElement()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CollaborationsPackage.COLLABORATION__NAMESPACE:
				return eBasicSetContainer(null, CollaborationsPackage.COLLABORATION__NAMESPACE, msgs);
			case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE, msgs);
			case CollaborationsPackage.COLLABORATION__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__INTERACTION:
				return ((InternalEList) getInteraction()).basicRemove(otherEnd, msgs);
			case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
				return ((InternalEList) getConstrainingElement()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CollaborationsPackage.COLLABORATION__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.COLLABORATION__NAME:
			return getName();
		case CollaborationsPackage.COLLABORATION__VISIBILITY:
			return getVisibility();
		case CollaborationsPackage.COLLABORATION__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.COLLABORATION__NAMESPACE:
			return getNamespace();
		case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CollaborationsPackage.COLLABORATION__CONSTRAINT:
			return getConstraint();
		case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CollaborationsPackage.COLLABORATION__PRESENTATION:
			return getPresentation();
		case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
			return getTargetFlow();
		case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
			return getSourceFlow();
		case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CollaborationsPackage.COLLABORATION__COMMENT:
			return getComment();
		case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CollaborationsPackage.COLLABORATION__STEREOTYPE:
			return getStereotype();
		case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
			return getTaggedValue();
		case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
			return getReferenceTag();
		case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CollaborationsPackage.COLLABORATION__BEHAVIOR:
			return getBehavior();
		case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CollaborationsPackage.COLLABORATION__COLLABORATION:
			return getCollaboration();
		case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CollaborationsPackage.COLLABORATION__PARTITION:
			return getPartition();
		case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
			return getElementImport();
		case CollaborationsPackage.COLLABORATION__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.COLLABORATION__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.COLLABORATION__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CollaborationsPackage.COLLABORATION__GENERALIZATION:
			return getGeneralization();
		case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
			return getSpecialization();
		case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
			return getOwnedElement();
		case CollaborationsPackage.COLLABORATION__INTERACTION:
			return getInteraction();
		case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
			return getConstrainingElement();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.COLLABORATION__NAME:
			setName((String) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.COLLABORATION__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.COLLABORATION__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.COLLABORATION__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CollaborationsPackage.COLLABORATION__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__INTERACTION:
			getInteraction().clear();
			getInteraction().addAll((Collection) newValue);
			return;
		case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
			getConstrainingElement().clear();
			getConstrainingElement().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.COLLABORATION__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CollaborationsPackage.COLLABORATION__CONSTRAINT:
			getConstraint().clear();
			return;
		case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CollaborationsPackage.COLLABORATION__PRESENTATION:
			getPresentation().clear();
			return;
		case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CollaborationsPackage.COLLABORATION__COMMENT:
			getComment().clear();
			return;
		case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CollaborationsPackage.COLLABORATION__STEREOTYPE:
			getStereotype().clear();
			return;
		case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CollaborationsPackage.COLLABORATION__BEHAVIOR:
			getBehavior().clear();
			return;
		case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CollaborationsPackage.COLLABORATION__COLLABORATION:
			getCollaboration().clear();
			return;
		case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CollaborationsPackage.COLLABORATION__PARTITION:
			getPartition().clear();
			return;
		case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CollaborationsPackage.COLLABORATION__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CollaborationsPackage.COLLABORATION__GENERALIZATION:
			getGeneralization().clear();
			return;
		case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case CollaborationsPackage.COLLABORATION__INTERACTION:
			getInteraction().clear();
			return;
		case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
			getConstrainingElement().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CollaborationsPackage.COLLABORATION__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CollaborationsPackage.COLLABORATION__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CollaborationsPackage.COLLABORATION__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CollaborationsPackage.COLLABORATION__NAMESPACE:
			return getNamespace() != null;
		case CollaborationsPackage.COLLABORATION__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CollaborationsPackage.COLLABORATION__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CollaborationsPackage.COLLABORATION__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CollaborationsPackage.COLLABORATION__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CollaborationsPackage.COLLABORATION__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CollaborationsPackage.COLLABORATION__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CollaborationsPackage.COLLABORATION__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CollaborationsPackage.COLLABORATION__COMMENT:
			return comment != null && !comment.isEmpty();
		case CollaborationsPackage.COLLABORATION__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CollaborationsPackage.COLLABORATION__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CollaborationsPackage.COLLABORATION__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CollaborationsPackage.COLLABORATION__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CollaborationsPackage.COLLABORATION__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CollaborationsPackage.COLLABORATION__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CollaborationsPackage.COLLABORATION__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CollaborationsPackage.COLLABORATION__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CollaborationsPackage.COLLABORATION__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CollaborationsPackage.COLLABORATION__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CollaborationsPackage.COLLABORATION__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CollaborationsPackage.COLLABORATION__PARTITION:
			return partition != null && !partition.isEmpty();
		case CollaborationsPackage.COLLABORATION__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CollaborationsPackage.COLLABORATION__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CollaborationsPackage.COLLABORATION__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CollaborationsPackage.COLLABORATION__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CollaborationsPackage.COLLABORATION__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case CollaborationsPackage.COLLABORATION__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case CollaborationsPackage.COLLABORATION__INTERACTION:
			return interaction != null && !interaction.isEmpty();
		case CollaborationsPackage.COLLABORATION__CONSTRAINING_ELEMENT:
			return constrainingElement != null && !constrainingElement.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int eBaseStructuralFeatureID(int derivedFeatureID, Class baseClass) {
		if (baseClass == Namespace.class) {
			switch (derivedFeatureID) {
			case CollaborationsPackage.COLLABORATION__OWNED_ELEMENT:
				return CorePackage.NAMESPACE__OWNED_ELEMENT;
			default:
				return -1;
			}
		}
		return super.eBaseStructuralFeatureID(derivedFeatureID, baseClass);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public int eDerivedStructuralFeatureID(int baseFeatureID, Class baseClass) {
		if (baseClass == Namespace.class) {
			switch (baseFeatureID) {
			case CorePackage.NAMESPACE__OWNED_ELEMENT:
				return CollaborationsPackage.COLLABORATION__OWNED_ELEMENT;
			default:
				return -1;
			}
		}
		return super.eDerivedStructuralFeatureID(baseFeatureID, baseClass);
	}

} // CollaborationImpl
