/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.behavioral_elements.common_behavior;

import org.eclipse.emf.common.util.EList;

import fr.obeo.acceleo.uml14.foundation.core.ModelElement;

/**
 * <!-- begin-user-doc --> A representation of the model object '
 * <em><b>Stimulus</b></em>'. <!-- end-user-doc -->
 * 
 * <p>
 * The following features are supported:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getArgument
 * <em>Argument</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getCommunicationLink
 * <em>Communication Link</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getDispatchAction
 * <em>Dispatch Action</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getPlayedRole
 * <em>Played Role</em>}</li>
 * <li>
 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getInteractionInstanceSet
 * <em>Interaction Instance Set</em>}</li>
 * </ul>
 * </p>
 * 
 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus()
 * @model
 * @generated
 */
public interface Stimulus extends ModelElement {
	/**
	 * Returns the value of the '<em><b>Argument</b></em>' reference list.
	 * The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance#getStimulus
	 * <em>Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Argument</em>' reference list isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Argument</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_Argument()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance#getStimulus
	 * @model type=
	 *        "fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Instance"
	 *        opposite="stimulus"
	 * @generated
	 */
	EList getArgument();

	/**
	 * Returns the value of the '<em><b>Communication Link</b></em>'
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Link#getStimulus
	 * <em>Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Communication Link</em>' reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Communication Link</em>' reference.
	 * @see #setCommunicationLink(Link)
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_CommunicationLink()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Link#getStimulus
	 * @model opposite="stimulus"
	 * @generated
	 */
	Link getCommunicationLink();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getCommunicationLink
	 * <em>Communication Link</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Communication Link</em>'
	 *            reference.
	 * @see #getCommunicationLink()
	 * @generated
	 */
	void setCommunicationLink(Link value);

	/**
	 * Returns the value of the '<em><b>Dispatch Action</b></em>'
	 * reference. It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Action#getStimulus
	 * <em>Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Dispatch Action</em>' reference isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Dispatch Action</em>' reference.
	 * @see #setDispatchAction(Action)
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_DispatchAction()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Action#getStimulus
	 * @model opposite="stimulus" required="true"
	 * @generated
	 */
	Action getDispatchAction();

	/**
	 * Sets the value of the '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Stimulus#getDispatchAction
	 * <em>Dispatch Action</em>}' reference. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @param value
	 *            the new value of the '<em>Dispatch Action</em>' reference.
	 * @see #getDispatchAction()
	 * @generated
	 */
	void setDispatchAction(Action value);

	/**
	 * Returns the value of the '<em><b>Played Role</b></em>' reference
	 * list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message}.
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message#getConformingStimulus
	 * <em>Conforming Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Played Role</em>' reference list isn't
	 * clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Played Role</em>' reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_PlayedRole()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message#getConformingStimulus
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.collaborations.Message"
	 *        opposite="conformingStimulus"
	 * @generated
	 */
	EList getPlayedRole();

	/**
	 * Returns the value of the '<em><b>Interaction Instance Set</b></em>'
	 * reference list. The list contents are of type
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet} .
	 * It is bidirectional and its opposite is '
	 * {@link fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet#getParticipatingStimulus
	 * <em>Participating Stimulus</em>}'. <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Interaction Instance Set</em>' reference
	 * list isn't clear, there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * 
	 * @return the value of the '<em>Interaction Instance Set</em>'
	 *         reference list.
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.common_behavior.Common_behaviorPackage#getStimulus_InteractionInstanceSet()
	 * @see fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet#getParticipatingStimulus
	 * @model type="fr.obeo.acceleo.uml14.behavioral_elements.collaborations.InteractionInstanceSet"
	 *        opposite="participatingStimulus"
	 * @generated
	 */
	EList getInteractionInstanceSet();

} // Stimulus
