/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.core.impl;

import java.util.Collection;

import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.util.EObjectWithInverseResolvingEList;
import org.eclipse.emf.ecore.util.InternalEList;

import fr.obeo.acceleo.uml14.foundation.core.Artifact;
import fr.obeo.acceleo.uml14.foundation.core.Component;
import fr.obeo.acceleo.uml14.foundation.core.CorePackage;
import fr.obeo.acceleo.uml14.foundation.core.Namespace;
import fr.obeo.acceleo.uml14.foundation.core.TemplateParameter;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model object '
 * <em><b>Artifact</b></em>'. <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 * <li>
 * {@link fr.obeo.acceleo.uml14.foundation.core.impl.ArtifactImpl#getImplementationLocation
 * <em>Implementation Location</em>}</li>
 * </ul>
 * </p>
 * 
 * @generated
 */
public class ArtifactImpl extends ClassifierImpl implements Artifact {
	/**
	 * The cached value of the '{@link #getImplementationLocation()
	 * <em>Implementation Location</em>}' reference list. <!-- begin-user-doc
	 * --> <!-- end-user-doc -->
	 * 
	 * @see #getImplementationLocation()
	 * @generated
	 * @ordered
	 */
	protected EList implementationLocation = null;

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected ArtifactImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	protected EClass eStaticClass() {
		return CorePackage.eINSTANCE.getArtifact();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EList getImplementationLocation() {
		if (implementationLocation == null) {
			implementationLocation = new EObjectWithInverseResolvingEList.ManyInverse(Component.class, this, CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION, CorePackage.COMPONENT__IMPLEMENTATION);
		}
		return implementationLocation;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseAdd(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ARTIFACT__NAMESPACE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ARTIFACT__NAMESPACE, msgs);
			case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__PRESENTATION:
				return ((InternalEList) getPresentation()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__COMMENT:
				return ((InternalEList) getComment()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
				if (eContainer != null)
					msgs = eBasicRemoveFromContainer(msgs);
				return eBasicSetContainer(otherEnd, CorePackage.ARTIFACT__PARAMETER_TEMPLATE, msgs);
			case CorePackage.ARTIFACT__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__PARTITION:
				return ((InternalEList) getPartition()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__FEATURE:
				return ((InternalEList) getFeature()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__INSTANCE:
				return ((InternalEList) getInstance()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicAdd(otherEnd, msgs);
			case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
				return ((InternalEList) getImplementationLocation()).basicAdd(otherEnd, msgs);
			default:
				return eDynamicInverseAdd(otherEnd, featureID, baseClass, msgs);
			}
		}
		if (eContainer != null)
			msgs = eBasicRemoveFromContainer(msgs);
		return eBasicSetContainer(otherEnd, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
			case CorePackage.ARTIFACT__NAMESPACE:
				return eBasicSetContainer(null, CorePackage.ARTIFACT__NAMESPACE, msgs);
			case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
				return ((InternalEList) getClientDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__CONSTRAINT:
				return ((InternalEList) getConstraint()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
				return ((InternalEList) getSupplierDependency()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__PRESENTATION:
				return ((InternalEList) getPresentation()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TARGET_FLOW:
				return ((InternalEList) getTargetFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__SOURCE_FLOW:
				return ((InternalEList) getSourceFlow()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
				return ((InternalEList) getDefaultedParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__COMMENT:
				return ((InternalEList) getComment()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
				return ((InternalEList) getElementResidence()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
				return ((InternalEList) getTemplateParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
				return eBasicSetContainer(null, CorePackage.ARTIFACT__PARAMETER_TEMPLATE, msgs);
			case CorePackage.ARTIFACT__STEREOTYPE:
				return ((InternalEList) getStereotype()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TAGGED_VALUE:
				return ((InternalEList) getTaggedValue()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__REFERENCE_TAG:
				return ((InternalEList) getReferenceTag()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
				return ((InternalEList) getTemplateArgument()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__BEHAVIOR:
				return ((InternalEList) getBehavior()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
				return ((InternalEList) getClassifierRole()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__COLLABORATION:
				return ((InternalEList) getCollaboration()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
				return ((InternalEList) getCollaborationInstanceSet()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__PARTITION:
				return ((InternalEList) getPartition()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__ELEMENT_IMPORT:
				return ((InternalEList) getElementImport()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__GENERALIZATION:
				return ((InternalEList) getGeneralization()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__SPECIALIZATION:
				return ((InternalEList) getSpecialization()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__OWNED_ELEMENT:
				return ((InternalEList) getOwnedElement()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__FEATURE:
				return ((InternalEList) getFeature()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TYPED_FEATURE:
				return ((InternalEList) getTypedFeature()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__TYPED_PARAMETER:
				return ((InternalEList) getTypedParameter()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__ASSOCIATION:
				return ((InternalEList) getAssociation()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__SPECIFIED_END:
				return ((InternalEList) getSpecifiedEnd()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__POWERTYPE_RANGE:
				return ((InternalEList) getPowertypeRange()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__INSTANCE:
				return ((InternalEList) getInstance()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__CREATE_ACTION:
				return ((InternalEList) getCreateAction()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
				return ((InternalEList) getClassifierInState()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
				return ((InternalEList) getObjectFlowState()).basicRemove(otherEnd, msgs);
			case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
				return ((InternalEList) getImplementationLocation()).basicRemove(otherEnd, msgs);
			default:
				return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public NotificationChain eBasicRemoveFromContainer(NotificationChain msgs) {
		if (eContainerFeatureID >= 0) {
			switch (eContainerFeatureID) {
			case CorePackage.ARTIFACT__NAMESPACE:
				return eContainer.eInverseRemove(this, CorePackage.NAMESPACE__OWNED_ELEMENT, Namespace.class, msgs);
			case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
				return eContainer.eInverseRemove(this, CorePackage.TEMPLATE_PARAMETER__PARAMETER, TemplateParameter.class, msgs);
			default:
				return eDynamicBasicRemoveFromContainer(msgs);
			}
		}
		return eContainer.eInverseRemove(this, EOPPOSITE_FEATURE_BASE - eContainerFeatureID, null, msgs);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ARTIFACT__NAME:
			return getName();
		case CorePackage.ARTIFACT__VISIBILITY:
			return getVisibility();
		case CorePackage.ARTIFACT__IS_SPECIFICATION:
			return isIsSpecification() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ARTIFACT__NAMESPACE:
			return getNamespace();
		case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
			return getClientDependency();
		case CorePackage.ARTIFACT__CONSTRAINT:
			return getConstraint();
		case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
			return getSupplierDependency();
		case CorePackage.ARTIFACT__PRESENTATION:
			return getPresentation();
		case CorePackage.ARTIFACT__TARGET_FLOW:
			return getTargetFlow();
		case CorePackage.ARTIFACT__SOURCE_FLOW:
			return getSourceFlow();
		case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
			return getDefaultedParameter();
		case CorePackage.ARTIFACT__COMMENT:
			return getComment();
		case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
			return getElementResidence();
		case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
			return getTemplateParameter();
		case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
			return getParameterTemplate();
		case CorePackage.ARTIFACT__STEREOTYPE:
			return getStereotype();
		case CorePackage.ARTIFACT__TAGGED_VALUE:
			return getTaggedValue();
		case CorePackage.ARTIFACT__REFERENCE_TAG:
			return getReferenceTag();
		case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
			return getTemplateArgument();
		case CorePackage.ARTIFACT__BEHAVIOR:
			return getBehavior();
		case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
			return getClassifierRole();
		case CorePackage.ARTIFACT__COLLABORATION:
			return getCollaboration();
		case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
			return getCollaborationInstanceSet();
		case CorePackage.ARTIFACT__PARTITION:
			return getPartition();
		case CorePackage.ARTIFACT__ELEMENT_IMPORT:
			return getElementImport();
		case CorePackage.ARTIFACT__IS_ROOT:
			return isIsRoot() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ARTIFACT__IS_LEAF:
			return isIsLeaf() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ARTIFACT__IS_ABSTRACT:
			return isIsAbstract() ? Boolean.TRUE : Boolean.FALSE;
		case CorePackage.ARTIFACT__GENERALIZATION:
			return getGeneralization();
		case CorePackage.ARTIFACT__SPECIALIZATION:
			return getSpecialization();
		case CorePackage.ARTIFACT__OWNED_ELEMENT:
			return getOwnedElement();
		case CorePackage.ARTIFACT__FEATURE:
			return getFeature();
		case CorePackage.ARTIFACT__TYPED_FEATURE:
			return getTypedFeature();
		case CorePackage.ARTIFACT__TYPED_PARAMETER:
			return getTypedParameter();
		case CorePackage.ARTIFACT__ASSOCIATION:
			return getAssociation();
		case CorePackage.ARTIFACT__SPECIFIED_END:
			return getSpecifiedEnd();
		case CorePackage.ARTIFACT__POWERTYPE_RANGE:
			return getPowertypeRange();
		case CorePackage.ARTIFACT__INSTANCE:
			return getInstance();
		case CorePackage.ARTIFACT__CREATE_ACTION:
			return getCreateAction();
		case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
			return getClassifierInState();
		case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
			return getObjectFlowState();
		case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
			return getImplementationLocation();
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ARTIFACT__NAME:
			setName((String) newValue);
			return;
		case CorePackage.ARTIFACT__VISIBILITY:
			setVisibility((VisibilityKind) newValue);
			return;
		case CorePackage.ARTIFACT__IS_SPECIFICATION:
			setIsSpecification(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ARTIFACT__NAMESPACE:
			setNamespace((Namespace) newValue);
			return;
		case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			getClientDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__CONSTRAINT:
			getConstraint().clear();
			getConstraint().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			getSupplierDependency().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__PRESENTATION:
			getPresentation().clear();
			getPresentation().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TARGET_FLOW:
			getTargetFlow().clear();
			getTargetFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__SOURCE_FLOW:
			getSourceFlow().clear();
			getSourceFlow().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			getDefaultedParameter().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__COMMENT:
			getComment().clear();
			getComment().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			getElementResidence().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			getTemplateParameter().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) newValue);
			return;
		case CorePackage.ARTIFACT__STEREOTYPE:
			getStereotype().clear();
			getStereotype().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TAGGED_VALUE:
			getTaggedValue().clear();
			getTaggedValue().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__REFERENCE_TAG:
			getReferenceTag().clear();
			getReferenceTag().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			getTemplateArgument().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__BEHAVIOR:
			getBehavior().clear();
			getBehavior().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			getClassifierRole().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__COLLABORATION:
			getCollaboration().clear();
			getCollaboration().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			getCollaborationInstanceSet().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__PARTITION:
			getPartition().clear();
			getPartition().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__ELEMENT_IMPORT:
			getElementImport().clear();
			getElementImport().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__IS_ROOT:
			setIsRoot(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ARTIFACT__IS_LEAF:
			setIsLeaf(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ARTIFACT__IS_ABSTRACT:
			setIsAbstract(((Boolean) newValue).booleanValue());
			return;
		case CorePackage.ARTIFACT__GENERALIZATION:
			getGeneralization().clear();
			getGeneralization().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__SPECIALIZATION:
			getSpecialization().clear();
			getSpecialization().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__OWNED_ELEMENT:
			getOwnedElement().clear();
			getOwnedElement().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__FEATURE:
			getFeature().clear();
			getFeature().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TYPED_FEATURE:
			getTypedFeature().clear();
			getTypedFeature().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__TYPED_PARAMETER:
			getTypedParameter().clear();
			getTypedParameter().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__ASSOCIATION:
			getAssociation().clear();
			getAssociation().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__SPECIFIED_END:
			getSpecifiedEnd().clear();
			getSpecifiedEnd().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			getPowertypeRange().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__INSTANCE:
			getInstance().clear();
			getInstance().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__CREATE_ACTION:
			getCreateAction().clear();
			getCreateAction().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			getClassifierInState().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			getObjectFlowState().addAll((Collection) newValue);
			return;
		case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
			getImplementationLocation().clear();
			getImplementationLocation().addAll((Collection) newValue);
			return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ARTIFACT__NAME:
			setName(NAME_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__VISIBILITY:
			setVisibility(VISIBILITY_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__IS_SPECIFICATION:
			setIsSpecification(IS_SPECIFICATION_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__NAMESPACE:
			setNamespace((Namespace) null);
			return;
		case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
			getClientDependency().clear();
			return;
		case CorePackage.ARTIFACT__CONSTRAINT:
			getConstraint().clear();
			return;
		case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
			getSupplierDependency().clear();
			return;
		case CorePackage.ARTIFACT__PRESENTATION:
			getPresentation().clear();
			return;
		case CorePackage.ARTIFACT__TARGET_FLOW:
			getTargetFlow().clear();
			return;
		case CorePackage.ARTIFACT__SOURCE_FLOW:
			getSourceFlow().clear();
			return;
		case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
			getDefaultedParameter().clear();
			return;
		case CorePackage.ARTIFACT__COMMENT:
			getComment().clear();
			return;
		case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
			getElementResidence().clear();
			return;
		case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
			getTemplateParameter().clear();
			return;
		case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
			setParameterTemplate((TemplateParameter) null);
			return;
		case CorePackage.ARTIFACT__STEREOTYPE:
			getStereotype().clear();
			return;
		case CorePackage.ARTIFACT__TAGGED_VALUE:
			getTaggedValue().clear();
			return;
		case CorePackage.ARTIFACT__REFERENCE_TAG:
			getReferenceTag().clear();
			return;
		case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
			getTemplateArgument().clear();
			return;
		case CorePackage.ARTIFACT__BEHAVIOR:
			getBehavior().clear();
			return;
		case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
			getClassifierRole().clear();
			return;
		case CorePackage.ARTIFACT__COLLABORATION:
			getCollaboration().clear();
			return;
		case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
			getCollaborationInstanceSet().clear();
			return;
		case CorePackage.ARTIFACT__PARTITION:
			getPartition().clear();
			return;
		case CorePackage.ARTIFACT__ELEMENT_IMPORT:
			getElementImport().clear();
			return;
		case CorePackage.ARTIFACT__IS_ROOT:
			setIsRoot(IS_ROOT_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__IS_LEAF:
			setIsLeaf(IS_LEAF_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__IS_ABSTRACT:
			setIsAbstract(IS_ABSTRACT_EDEFAULT);
			return;
		case CorePackage.ARTIFACT__GENERALIZATION:
			getGeneralization().clear();
			return;
		case CorePackage.ARTIFACT__SPECIALIZATION:
			getSpecialization().clear();
			return;
		case CorePackage.ARTIFACT__OWNED_ELEMENT:
			getOwnedElement().clear();
			return;
		case CorePackage.ARTIFACT__FEATURE:
			getFeature().clear();
			return;
		case CorePackage.ARTIFACT__TYPED_FEATURE:
			getTypedFeature().clear();
			return;
		case CorePackage.ARTIFACT__TYPED_PARAMETER:
			getTypedParameter().clear();
			return;
		case CorePackage.ARTIFACT__ASSOCIATION:
			getAssociation().clear();
			return;
		case CorePackage.ARTIFACT__SPECIFIED_END:
			getSpecifiedEnd().clear();
			return;
		case CorePackage.ARTIFACT__POWERTYPE_RANGE:
			getPowertypeRange().clear();
			return;
		case CorePackage.ARTIFACT__INSTANCE:
			getInstance().clear();
			return;
		case CorePackage.ARTIFACT__CREATE_ACTION:
			getCreateAction().clear();
			return;
		case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
			getClassifierInState().clear();
			return;
		case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
			getObjectFlowState().clear();
			return;
		case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
			getImplementationLocation().clear();
			return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
		case CorePackage.ARTIFACT__NAME:
			return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
		case CorePackage.ARTIFACT__VISIBILITY:
			return visibility != VISIBILITY_EDEFAULT;
		case CorePackage.ARTIFACT__IS_SPECIFICATION:
			return isSpecification != IS_SPECIFICATION_EDEFAULT;
		case CorePackage.ARTIFACT__NAMESPACE:
			return getNamespace() != null;
		case CorePackage.ARTIFACT__CLIENT_DEPENDENCY:
			return clientDependency != null && !clientDependency.isEmpty();
		case CorePackage.ARTIFACT__CONSTRAINT:
			return constraint != null && !constraint.isEmpty();
		case CorePackage.ARTIFACT__SUPPLIER_DEPENDENCY:
			return supplierDependency != null && !supplierDependency.isEmpty();
		case CorePackage.ARTIFACT__PRESENTATION:
			return presentation != null && !presentation.isEmpty();
		case CorePackage.ARTIFACT__TARGET_FLOW:
			return targetFlow != null && !targetFlow.isEmpty();
		case CorePackage.ARTIFACT__SOURCE_FLOW:
			return sourceFlow != null && !sourceFlow.isEmpty();
		case CorePackage.ARTIFACT__DEFAULTED_PARAMETER:
			return defaultedParameter != null && !defaultedParameter.isEmpty();
		case CorePackage.ARTIFACT__COMMENT:
			return comment != null && !comment.isEmpty();
		case CorePackage.ARTIFACT__ELEMENT_RESIDENCE:
			return elementResidence != null && !elementResidence.isEmpty();
		case CorePackage.ARTIFACT__TEMPLATE_PARAMETER:
			return templateParameter != null && !templateParameter.isEmpty();
		case CorePackage.ARTIFACT__PARAMETER_TEMPLATE:
			return getParameterTemplate() != null;
		case CorePackage.ARTIFACT__STEREOTYPE:
			return stereotype != null && !stereotype.isEmpty();
		case CorePackage.ARTIFACT__TAGGED_VALUE:
			return taggedValue != null && !taggedValue.isEmpty();
		case CorePackage.ARTIFACT__REFERENCE_TAG:
			return referenceTag != null && !referenceTag.isEmpty();
		case CorePackage.ARTIFACT__TEMPLATE_ARGUMENT:
			return templateArgument != null && !templateArgument.isEmpty();
		case CorePackage.ARTIFACT__BEHAVIOR:
			return behavior != null && !behavior.isEmpty();
		case CorePackage.ARTIFACT__CLASSIFIER_ROLE:
			return classifierRole != null && !classifierRole.isEmpty();
		case CorePackage.ARTIFACT__COLLABORATION:
			return collaboration != null && !collaboration.isEmpty();
		case CorePackage.ARTIFACT__COLLABORATION_INSTANCE_SET:
			return collaborationInstanceSet != null && !collaborationInstanceSet.isEmpty();
		case CorePackage.ARTIFACT__PARTITION:
			return partition != null && !partition.isEmpty();
		case CorePackage.ARTIFACT__ELEMENT_IMPORT:
			return elementImport != null && !elementImport.isEmpty();
		case CorePackage.ARTIFACT__IS_ROOT:
			return isRoot != IS_ROOT_EDEFAULT;
		case CorePackage.ARTIFACT__IS_LEAF:
			return isLeaf != IS_LEAF_EDEFAULT;
		case CorePackage.ARTIFACT__IS_ABSTRACT:
			return isAbstract != IS_ABSTRACT_EDEFAULT;
		case CorePackage.ARTIFACT__GENERALIZATION:
			return generalization != null && !generalization.isEmpty();
		case CorePackage.ARTIFACT__SPECIALIZATION:
			return specialization != null && !specialization.isEmpty();
		case CorePackage.ARTIFACT__OWNED_ELEMENT:
			return ownedElement != null && !ownedElement.isEmpty();
		case CorePackage.ARTIFACT__FEATURE:
			return feature != null && !feature.isEmpty();
		case CorePackage.ARTIFACT__TYPED_FEATURE:
			return typedFeature != null && !typedFeature.isEmpty();
		case CorePackage.ARTIFACT__TYPED_PARAMETER:
			return typedParameter != null && !typedParameter.isEmpty();
		case CorePackage.ARTIFACT__ASSOCIATION:
			return association != null && !association.isEmpty();
		case CorePackage.ARTIFACT__SPECIFIED_END:
			return specifiedEnd != null && !specifiedEnd.isEmpty();
		case CorePackage.ARTIFACT__POWERTYPE_RANGE:
			return powertypeRange != null && !powertypeRange.isEmpty();
		case CorePackage.ARTIFACT__INSTANCE:
			return instance != null && !instance.isEmpty();
		case CorePackage.ARTIFACT__CREATE_ACTION:
			return createAction != null && !createAction.isEmpty();
		case CorePackage.ARTIFACT__CLASSIFIER_IN_STATE:
			return classifierInState != null && !classifierInState.isEmpty();
		case CorePackage.ARTIFACT__OBJECT_FLOW_STATE:
			return objectFlowState != null && !objectFlowState.isEmpty();
		case CorePackage.ARTIFACT__IMPLEMENTATION_LOCATION:
			return implementationLocation != null && !implementationLocation.isEmpty();
		}
		return eDynamicIsSet(eFeature);
	}

} // ArtifactImpl
