/**
 * <copyright>
 * </copyright>
 *
 * $Id$
 */
package fr.obeo.acceleo.uml14.foundation.data_types.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EDataType;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.impl.EFactoryImpl;

import fr.obeo.acceleo.uml14.foundation.data_types.ActionExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.AggregationKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ArgListsExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.BooleanExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.CallConcurrencyKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ChangeableKind;
import fr.obeo.acceleo.uml14.foundation.data_types.Data_typesFactory;
import fr.obeo.acceleo.uml14.foundation.data_types.Data_typesPackage;
import fr.obeo.acceleo.uml14.foundation.data_types.Expression;
import fr.obeo.acceleo.uml14.foundation.data_types.IterationExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.MappingExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.Multiplicity;
import fr.obeo.acceleo.uml14.foundation.data_types.MultiplicityRange;
import fr.obeo.acceleo.uml14.foundation.data_types.ObjectSetExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.OrderingKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ParameterDirectionKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ProcedureExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.PseudostateKind;
import fr.obeo.acceleo.uml14.foundation.data_types.ScopeKind;
import fr.obeo.acceleo.uml14.foundation.data_types.TimeExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.TypeExpression;
import fr.obeo.acceleo.uml14.foundation.data_types.VisibilityKind;

/**
 * <!-- begin-user-doc --> An implementation of the model <b>Factory</b>. <!--
 * end-user-doc -->
 * 
 * @generated
 */
public class Data_typesFactoryImpl extends EFactoryImpl implements Data_typesFactory {
	/**
	 * Creates an instance of the factory. <!-- begin-user-doc --> <!--
	 * end-user-doc -->
	 * 
	 * @generated
	 */
	public Data_typesFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
		case Data_typesPackage.MULTIPLICITY:
			return createMultiplicity();
		case Data_typesPackage.MULTIPLICITY_RANGE:
			return createMultiplicityRange();
		case Data_typesPackage.EXPRESSION:
			return createExpression();
		case Data_typesPackage.BOOLEAN_EXPRESSION:
			return createBooleanExpression();
		case Data_typesPackage.TYPE_EXPRESSION:
			return createTypeExpression();
		case Data_typesPackage.MAPPING_EXPRESSION:
			return createMappingExpression();
		case Data_typesPackage.PROCEDURE_EXPRESSION:
			return createProcedureExpression();
		case Data_typesPackage.OBJECT_SET_EXPRESSION:
			return createObjectSetExpression();
		case Data_typesPackage.ACTION_EXPRESSION:
			return createActionExpression();
		case Data_typesPackage.ITERATION_EXPRESSION:
			return createIterationExpression();
		case Data_typesPackage.TIME_EXPRESSION:
			return createTimeExpression();
		case Data_typesPackage.ARG_LISTS_EXPRESSION:
			return createArgListsExpression();
		default:
			throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Object createFromString(EDataType eDataType, String initialValue) {
		switch (eDataType.getClassifierID()) {
		case Data_typesPackage.AGGREGATION_KIND: {
			AggregationKind result = AggregationKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.CALL_CONCURRENCY_KIND: {
			CallConcurrencyKind result = CallConcurrencyKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.CHANGEABLE_KIND: {
			ChangeableKind result = ChangeableKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.ORDERING_KIND: {
			OrderingKind result = OrderingKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.PARAMETER_DIRECTION_KIND: {
			ParameterDirectionKind result = ParameterDirectionKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.SCOPE_KIND: {
			ScopeKind result = ScopeKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.VISIBILITY_KIND: {
			VisibilityKind result = VisibilityKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.PSEUDOSTATE_KIND: {
			PseudostateKind result = PseudostateKind.get(initialValue);
			if (result == null)
				throw new IllegalArgumentException("The value '" + initialValue + "' is not a valid enumerator of '" + eDataType.getName() + "'"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$
			return result;
		}
		case Data_typesPackage.INTEGER:
			return createIntegerFromString(eDataType, initialValue);
		case Data_typesPackage.UNLIMITED_INTEGER:
			return createUnlimitedIntegerFromString(eDataType, initialValue);
		case Data_typesPackage.STRING:
			return createStringFromString(eDataType, initialValue);
		case Data_typesPackage.BOOLEAN:
			return createBooleanFromString(eDataType, initialValue);
		case Data_typesPackage.NAME:
			return createNameFromString(eDataType, initialValue);
		case Data_typesPackage.LOCATION_REFERENCE:
			return createLocationReferenceFromString(eDataType, initialValue);
		case Data_typesPackage.GEOMETRY:
			return createGeometryFromString(eDataType, initialValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertToString(EDataType eDataType, Object instanceValue) {
		switch (eDataType.getClassifierID()) {
		case Data_typesPackage.AGGREGATION_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.CALL_CONCURRENCY_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.CHANGEABLE_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.ORDERING_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.PARAMETER_DIRECTION_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.SCOPE_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.VISIBILITY_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.PSEUDOSTATE_KIND:
			return instanceValue == null ? null : instanceValue.toString();
		case Data_typesPackage.INTEGER:
			return convertIntegerToString(eDataType, instanceValue);
		case Data_typesPackage.UNLIMITED_INTEGER:
			return convertUnlimitedIntegerToString(eDataType, instanceValue);
		case Data_typesPackage.STRING:
			return convertStringToString(eDataType, instanceValue);
		case Data_typesPackage.BOOLEAN:
			return convertBooleanToString(eDataType, instanceValue);
		case Data_typesPackage.NAME:
			return convertNameToString(eDataType, instanceValue);
		case Data_typesPackage.LOCATION_REFERENCE:
			return convertLocationReferenceToString(eDataType, instanceValue);
		case Data_typesPackage.GEOMETRY:
			return convertGeometryToString(eDataType, instanceValue);
		default:
			throw new IllegalArgumentException("The datatype '" + eDataType.getName() + "' is not a valid classifier"); //$NON-NLS-1$ //$NON-NLS-2$
		}
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Multiplicity createMultiplicity() {
		MultiplicityImpl multiplicity = new MultiplicityImpl();
		return multiplicity;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public MultiplicityRange createMultiplicityRange() {
		MultiplicityRangeImpl multiplicityRange = new MultiplicityRangeImpl();
		return multiplicityRange;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Expression createExpression() {
		ExpressionImpl expression = new ExpressionImpl();
		return expression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public BooleanExpression createBooleanExpression() {
		BooleanExpressionImpl booleanExpression = new BooleanExpressionImpl();
		return booleanExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TypeExpression createTypeExpression() {
		TypeExpressionImpl typeExpression = new TypeExpressionImpl();
		return typeExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public MappingExpression createMappingExpression() {
		MappingExpressionImpl mappingExpression = new MappingExpressionImpl();
		return mappingExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ProcedureExpression createProcedureExpression() {
		ProcedureExpressionImpl procedureExpression = new ProcedureExpressionImpl();
		return procedureExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ObjectSetExpression createObjectSetExpression() {
		ObjectSetExpressionImpl objectSetExpression = new ObjectSetExpressionImpl();
		return objectSetExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ActionExpression createActionExpression() {
		ActionExpressionImpl actionExpression = new ActionExpressionImpl();
		return actionExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public IterationExpression createIterationExpression() {
		IterationExpressionImpl iterationExpression = new IterationExpressionImpl();
		return iterationExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public TimeExpression createTimeExpression() {
		TimeExpressionImpl timeExpression = new TimeExpressionImpl();
		return timeExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public ArgListsExpression createArgListsExpression() {
		ArgListsExpressionImpl argListsExpression = new ArgListsExpressionImpl();
		return argListsExpression;
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Long createIntegerFromString(EDataType eDataType, String initialValue) {
		return (Long) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertIntegerToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Long createUnlimitedIntegerFromString(EDataType eDataType, String initialValue) {
		return (Long) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertUnlimitedIntegerToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String createStringFromString(EDataType eDataType, String initialValue) {
		return (String) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertStringToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Boolean createBooleanFromString(EDataType eDataType, String initialValue) {
		return (Boolean) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertBooleanToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String createNameFromString(EDataType eDataType, String initialValue) {
		return (String) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertNameToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String createLocationReferenceFromString(EDataType eDataType, String initialValue) {
		return (String) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertLocationReferenceToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String createGeometryFromString(EDataType eDataType, String initialValue) {
		return (String) super.createFromString(eDataType, initialValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public String convertGeometryToString(EDataType eDataType, Object instanceValue) {
		return super.convertToString(eDataType, instanceValue);
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @generated
	 */
	public Data_typesPackage getData_typesPackage() {
		return (Data_typesPackage) getEPackage();
	}

	/**
	 * <!-- begin-user-doc --> <!-- end-user-doc -->
	 * 
	 * @deprecated
	 * @generated
	 */
	public static Data_typesPackage getPackage() {
		return Data_typesPackage.eINSTANCE;
	}

} // Data_typesFactoryImpl
